/* orfeomeImageIds.c was originally generated by the autoSql program, which also 
 * generated orfeomeImageIds.h and orfeomeImageIds.sql.  This module links the database and
 * the RAM representation of objects. */

#include "common.h"
#include "linefile.h"
#include "dystring.h"
#include "jksql.h"
#include "orfeomeImageIds.h"


void orfeomeImageIdsStaticLoad(char **row, struct orfeomeImageIds *ret)
/* Load a row from orfeomeImageIds table into ret.  The contents of ret will
 * be replaced at the next call to this function. */
{

ret->imageFirst = sqlSigned(row[0]);
ret->imageLast = sqlSigned(row[1]);
ret->organism = row[2];
ret->comment = row[3];
}

struct orfeomeImageIds *orfeomeImageIdsLoad(char **row)
/* Load a orfeomeImageIds from row fetched with select * from orfeomeImageIds
 * from database.  Dispose of this with orfeomeImageIdsFree(). */
{
struct orfeomeImageIds *ret;

AllocVar(ret);
ret->imageFirst = sqlSigned(row[0]);
ret->imageLast = sqlSigned(row[1]);
ret->organism = cloneString(row[2]);
ret->comment = cloneString(row[3]);
return ret;
}

struct orfeomeImageIds *orfeomeImageIdsLoadAll(char *fileName) 
/* Load all orfeomeImageIds from a whitespace-separated file.
 * Dispose of this with orfeomeImageIdsFreeList(). */
{
struct orfeomeImageIds *list = NULL, *el;
struct lineFile *lf = lineFileOpen(fileName, TRUE);
char *row[4];

while (lineFileRow(lf, row))
    {
    el = orfeomeImageIdsLoad(row);
    slAddHead(&list, el);
    }
lineFileClose(&lf);
slReverse(&list);
return list;
}

struct orfeomeImageIds *orfeomeImageIdsLoadAllByChar(char *fileName, char chopper) 
/* Load all orfeomeImageIds from a chopper separated file.
 * Dispose of this with orfeomeImageIdsFreeList(). */
{
struct orfeomeImageIds *list = NULL, *el;
struct lineFile *lf = lineFileOpen(fileName, TRUE);
char *row[4];

while (lineFileNextCharRow(lf, chopper, row, ArraySize(row)))
    {
    el = orfeomeImageIdsLoad(row);
    slAddHead(&list, el);
    }
lineFileClose(&lf);
slReverse(&list);
return list;
}

struct orfeomeImageIds *orfeomeImageIdsCommaIn(char **pS, struct orfeomeImageIds *ret)
/* Create a orfeomeImageIds out of a comma separated string. 
 * This will fill in ret if non-null, otherwise will
 * return a new orfeomeImageIds */
{
char *s = *pS;

if (ret == NULL)
    AllocVar(ret);
ret->imageFirst = sqlSignedComma(&s);
ret->imageLast = sqlSignedComma(&s);
ret->organism = sqlStringComma(&s);
ret->comment = sqlStringComma(&s);
*pS = s;
return ret;
}

void orfeomeImageIdsFree(struct orfeomeImageIds **pEl)
/* Free a single dynamically allocated orfeomeImageIds such as created
 * with orfeomeImageIdsLoad(). */
{
struct orfeomeImageIds *el;

if ((el = *pEl) == NULL) return;
freeMem(el->organism);
freeMem(el->comment);
freez(pEl);
}

void orfeomeImageIdsFreeList(struct orfeomeImageIds **pList)
/* Free a list of dynamically allocated orfeomeImageIds's */
{
struct orfeomeImageIds *el, *next;

for (el = *pList; el != NULL; el = next)
    {
    next = el->next;
    orfeomeImageIdsFree(&el);
    }
*pList = NULL;
}

void orfeomeImageIdsOutput(struct orfeomeImageIds *el, FILE *f, char sep, char lastSep) 
/* Print out orfeomeImageIds.  Separate fields with sep. Follow last field with lastSep. */
{
fprintf(f, "%d", el->imageFirst);
fputc(sep,f);
fprintf(f, "%d", el->imageLast);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->organism);
if (sep == ',') fputc('"',f);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->comment);
if (sep == ',') fputc('"',f);
fputc(lastSep,f);
}

/* -------------------------------- End autoSql Generated Code -------------------------------- */

